
AC_DEFUN([DBG_CONFIG_NICE],[
  do_nice=true
  for ac_arg
  do
    case $ac_arg in
    -no-create | --no-c* | -n | -no-recursion | --no-r*) do_nice=false ;;
    esac
  done
  
if $do_nice; then
  test -f $1 && mv $1 $1.old
  rm -f $1.old
  cat >$1<<EOF
#! /bin/sh
#
# Created by configure

EOF

  for var in CFLAGS CXXFLAGS CPPFLAGS LDFLAGS LIBS CC CXX; do
    eval val=\$$var
    if test -n "$val"; then
      echo "$var='$val' \\" >> $1
    fi
  done

  for arg in [$]0 "[$]@"; do
    echo "'[$]arg' \\" >> $1
  done
  echo '"[$]@"' >> $1
  chmod +x $1
fi
])

AC_DEFUN([DBG_DEF_HAVE],[
    AC_DEFINE([HAVE_]translit($1,a-z_.-,A-Z___), 1, [ ])
])

AC_DEFUN([DBG_SOCKLEN_T],[
AC_CACHE_CHECK(for socklen_t,ac_cv_socklen_t,
  AC_TRY_COMPILE([
#include <sys/types.h>
#include <sys/socket.h>
],[
socklen_t x;
],[
  ac_cv_socklen_t=yes
],[
  ac_cv_socklen_t=no
]))
if test "$ac_cv_socklen_t" = "yes"; then
  AC_DEFINE(HAVE_SOCKLEN_T, 1, [Whether you have socklen_t])
fi
])

AC_DEFUN([DBG_ADD_LIB],[
    unset ac_cv_addl
    ifelse($2,,[ac_cv_addl="-l$1"],[ac_cv_addl="-L$2 -l$1"])
    ac_cv_addl_rslt=`echo $U_LIBS|grep -e "$ac_cv_addl"`
    if test -z "$ac_cv_addl_rslt"; then
	U_LIBS="$ac_cv_addl $U_LIBS"
    fi
])


ifdef([builtin],[builtin(define, dbgshift, [builtin(shift, $@)])],[
    define([dbgshift],[ifelse(index([$@],[,]),-1,,[substr([$@],incr(index([$@],[,])))])])
])
AC_DEFUN([DBG_CHECK_FUNC_LIB],[
    ifelse($2,,:,[
	unset ac_cv_lib_$2[]_$1
	unset found
	AC_CHECK_LIB($2, $1, [found=yes], [found=no])

	if test "$found" = "yes"; then
	    ac_libs=$LIBS
	    LIBS="$LIBS -l$2"
	    AC_TRY_RUN([main() { return (0); }],[found=yes],[found=no],[found=no])
	    LIBS=$ac_libs
	fi

	if test "$found" = "yes"; then
	    DBG_ADD_LIB($2)
	    DBG_DEF_HAVE($1)
	    DBG_DEF_HAVE(lib$2)
	    ac_cv_func_$1=yes
	else
	    DBG_CHECK_FUNC_LIB($1,dbgshift(dbgshift($@)))
	fi
    ])
])

AC_DEFUN([DBG_CHECK_FUNC],[
    unset ac_cv_func_$1
    unset found
        
    AC_CHECK_FUNC($1, [found=yes],[found=no])
	
    case $found in
	yes[)] 
	    DBG_DEF_HAVE($1)
	    ac_cv_func_$1=yes
	;;
	ifelse($#,1,,[
	    *[)] DBG_CHECK_FUNC_LIB($@) ;;
	])
    esac
])
				
