/***************************************************************************
                          dbgclient_classes.cpp  -  description
                             -------------------
    begin                : Sun Aug 5 2001
    author               : Dmitri Dmitrienko
    copyright            : (C) 2001, 2007, Dmitri Dmitrienko
    www                  : http://dd.cron.ru
    license              : This source file is subject to version 1.01 of 
                           the License,  that is bundled with this package 
                           in the file LICENSE, and is available at through 
                           the world-wide-web at http://dd.cron.ru/license
 ***************************************************************************/


#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef HAVE_ARPA_INET_H
#include <arpa/inet.h>
#endif
#ifdef HAVE_SYS_SOCKET_H
#include <sys/socket.h>
#endif
#ifdef HAVE_NETINET_IN_H
#include <netinet/in.h>
#endif
#ifdef HAVE_NETDB_H
#include <netdb.h>
#endif


#include "dbgclient_classes.h"


// ThreadClient

DbgSiteBase* ThreadClient::create_site() {
	return new DbgSite();
}

void ThreadClient::process() {
	ThreadBase::process();
	if (fsite == NULL) flags|=DBGF_FINISHED;
}

void ThreadClient::stop(bool bWait) {
	close(); // safe in non-multithreading env.
	flags = DBGF_FINISHED;
} 


// Listener

ThreadBase *Listener::create_client() {
	return new ThreadClient();
}

void Listener::statuschangedJIT() {
}

void Listener::log(ListenerLogKind kind, const char *message,...) {
}


/*
 * Local variables:
 * tab-width: 4
 * c-basic-offset: 4
 * End:
 */
