/***************************************************************************
                          dbgclient_classes.h  -  description
                             -------------------
    begin                : Sun Aug 5 2001
    author               : Dmitri Dmitrienko
    copyright            : (C) 2001, 2007, Dmitri Dmitrienko
    www                  : http://dd.cron.ru
    license              : This source file is subject to version 1.01 of 
                           the License,  that is bundled with this package 
                           in the file LICENSE, and is available at through 
                           the world-wide-web at http://dd.cron.ru/license
 ***************************************************************************/

#ifndef _DBGCLIENT_CLASSES_H_
#define _DBGCLIENT_CLASSES_H_


#include "dbgbase/dbgbase_classes.h"

class DbgSite: public DbgSiteBase {
private:
protected:
	RequestorBase *frequestor;
	std::string foutput;
	int fcurr_mod_no;
	int fcurr_line_no;	
	std::string fcurr_mod_name;
	std::string fcurr_src;
public:
	DbgSite() : frequestor(NULL) {}
	HRESULT initialize(RequestorBase *req, int dbg_ver, char *dbg_descr); 
	HRESULT handleerror(int errtype, char *errmsg, BP_ACTION *action);  
	HRESULT handlebreakpoint(BR_REASON reason, BP_ACTION *action);
	HRESULT log(int mod_no, int line_no, char *mod_name, int type, char *logmsg, int loglen);
	HRESULT close();
	RequestorBase *requestor() { return frequestor; }
	HRESULT delay_handling() { return S_OK; }
	HRESULT isalive();
	void get_output(std::string &output) { output.assign(foutput); }
	void update_curr_src();
	int curr_mod_no() { return fcurr_mod_no; }
	int curr_line_no() { return fcurr_line_no; }
	void get_curr_src(std::string &src) { src.assign(fcurr_src); }
};


class ThreadClient : public ThreadBase {
private:
protected:
	DbgSiteBase* create_site();
public:
	void stop(bool bWait);
	void process();
};


class Listener: public ListenerBase {
private:
protected:
	ThreadBase *create_client();
public:
	void statuschangedJIT();
	void log(ListenerLogKind kind, const char *message,...);
};

#endif
