/***************************************************************************
                          StrTable.h  -  description
                             -------------------
    begin                : Fri Mar 2 2001
    copyright            : (C) 2001 by Dmitri Dmitrienko
                         : (C) 2002, 2007 NuSphere Corp.
    www                  : http://dd.cron.ru
                         : http://www.nusphere.com/
    license              : This source file is subject to version 1.01 of 
                           the License,  that is bundled with this package 
                           in the file LICENSE, and is available at through 
                           the world-wide-web at http://dd.cron.ru/license
 ***************************************************************************/


#ifndef _STRTABLE_H_
#define _STRTABLE_H_

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <list>
#include <vector>
#include <string>
#include <algorithm>

#if HAVE_IOSTREAM
#include <iostream>
#elif HAVE_IOSTREAM_H
#include <iostream.h>
#endif

#if HAVE_OSTREAM
#include <ostream>
#endif

#include "dbgbase_classes.h"

std::string& trimleft(std::string& str);
std::string& trimright(std::string& str);
std::string& trimstr(std::string& str);

inline std::ostream& operator << (std::ostream& strm, const std::string& str) {
	strm << str.c_str();
	return strm;
}

inline bool operator < (const std::string& x, const std::string& y) {
    return (strcmp(x.c_str(),y.c_str())==-1);
}


inline bool operator == (const std::string& x, const std::string& y) {
    return (strcmp(x.c_str(),y.c_str())==0);
}

inline bool operator <= (const std::string& x, const std::string& y) {
    return (strcmp(x.c_str(),y.c_str())!=1);
}

inline bool operator < (const StringTableItem& x, const StringTableItem& y) {
    return x.key < y.key;
}

inline bool operator == (const StringTableItem& x, const StringTableItem& y) {
    return x.key == y.key;
}


inline std::ostream& operator << (std::ostream& strm, const StringTable& tb) {
	StringTableBase::const_iterator it;
	for (it = tb.begin(); it != tb.end(); it++) 
	   strm << it->key << "=" << it->val << "\n";
	return strm;
}


#endif
