/***************************************************************************
                          UrlParse.h  -  description
                             -------------------
    begin                : Fri Mar 2 2001
    copyright            : (C) 2001 by Dmitri Dmitrienko
                         : (C) 2002, 2007 NuSphere Corp.
    www                  : http://dd.cron.ru
                         : http://www.nusphere.com/
    license              : This source file is subject to version 1.01 of 
                           the License,  that is bundled with this package 
                           in the file LICENSE, and is available at through 
                           the world-wide-web at http://dd.cron.ru/license
 ***************************************************************************/


#ifndef _URLPARSE_
#define _URLPARSE_

#include <string>

class UrlParse {
protected:
	int ferr;
	std::string fscheme;
	std::string fpath;
	std::string fquery;
	std::string ffragment;
	std::string fuser;
	std::string fpass;
	std::string fhost;
	unsigned short fport;
public:
	UrlParse(const std::string& url);
	int is_ok() const {return ferr == 0;}
	int err() const {return ferr;}
	const std::string& scheme() const {return fscheme;}
	const std::string& path() const {return fpath;}
	const std::string& host() const {return fhost;}
	const std::string& query() const {return fquery;}
	unsigned short port() {return fport;}
};

#endif
